import { Action, AnyAction, Dispatch, Store, Unsubscribe } from 'redux';
export interface MapStateToProps<S, P> {
    (state: S): P;
}
export interface PropsChangedEvent<S, P, A extends Action = AnyAction> {
    newProps: P;
    prevProps: P;
    getState(): S;
    dispatch: Dispatch<A>;
}
export interface PropsChangedHandler<S, P, A extends Action = AnyAction> {
    (event: PropsChangedEvent<S, P, A>): void;
}
export interface BindStoreReturn<S = any, A extends Action = AnyAction> {
    dispatch: Dispatch<A>;
    getState(): S;
    subscribe(listener: () => void): Unsubscribe;
    connect<P>(mapStateToProps: MapStateToProps<S, P>, propsChangedHandler: PropsChangedHandler<S, P, A>): Unsubscribe;
}
export declare function bindStore<S = any, A extends Action = AnyAction>(store: Store<S, A>): BindStoreReturn;
